#[doc = "Register `F02` reader"]
pub struct R(crate::R<F02_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<F02_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<F02_SPEC>> for R {
    fn from(reader: crate::R<F02_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `F02` writer"]
pub struct W(crate::W<F02_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<F02_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<F02_SPEC>> for W {
    fn from(writer: crate::W<F02_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `F0_0` reader - Fifo 0 for UDB\\[n\\]"]
pub struct F0_0_R(crate::FieldReader<u8, u8>);
impl F0_0_R {
    pub(crate) fn new(bits: u8) -> Self {
        F0_0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for F0_0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `F0_0` writer - Fifo 0 for UDB\\[n\\]"]
pub struct F0_0_W<'a> {
    w: &'a mut W,
}
impl<'a> F0_0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u32 & 0xff);
        self.w
    }
}
#[doc = "Field `F0_1` reader - Fifo 0 for UDB\\[n+1\\]"]
pub struct F0_1_R(crate::FieldReader<u8, u8>);
impl F0_1_R {
    pub(crate) fn new(bits: u8) -> Self {
        F0_1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for F0_1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `F0_1` writer - Fifo 0 for UDB\\[n+1\\]"]
pub struct F0_1_W<'a> {
    w: &'a mut W,
}
impl<'a> F0_1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | ((value as u32 & 0xff) << 8);
        self.w
    }
}
#[doc = "Field `F0_2` reader - Fifo 0 for UDB\\[n+2\\]"]
pub struct F0_2_R(crate::FieldReader<u8, u8>);
impl F0_2_R {
    pub(crate) fn new(bits: u8) -> Self {
        F0_2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for F0_2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `F0_2` writer - Fifo 0 for UDB\\[n+2\\]"]
pub struct F0_2_W<'a> {
    w: &'a mut W,
}
impl<'a> F0_2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 16)) | ((value as u32 & 0xff) << 16);
        self.w
    }
}
#[doc = "Field `F0_3` reader - Fifo 0 for UDB\\[n+3\\]"]
pub struct F0_3_R(crate::FieldReader<u8, u8>);
impl F0_3_R {
    pub(crate) fn new(bits: u8) -> Self {
        F0_3_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for F0_3_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `F0_3` writer - Fifo 0 for UDB\\[n+3\\]"]
pub struct F0_3_W<'a> {
    w: &'a mut W,
}
impl<'a> F0_3_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 24)) | ((value as u32 & 0xff) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Fifo 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn f0_0(&self) -> F0_0_R {
        F0_0_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Fifo 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn f0_1(&self) -> F0_1_R {
        F0_1_R::new(((self.bits >> 8) & 0xff) as u8)
    }
    #[doc = "Bits 16:23 - Fifo 0 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn f0_2(&self) -> F0_2_R {
        F0_2_R::new(((self.bits >> 16) & 0xff) as u8)
    }
    #[doc = "Bits 24:31 - Fifo 0 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn f0_3(&self) -> F0_3_R {
        F0_3_R::new(((self.bits >> 24) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Fifo 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn f0_0(&mut self) -> F0_0_W {
        F0_0_W { w: self }
    }
    #[doc = "Bits 8:15 - Fifo 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn f0_1(&mut self) -> F0_1_W {
        F0_1_W { w: self }
    }
    #[doc = "Bits 16:23 - Fifo 0 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn f0_2(&mut self) -> F0_2_W {
        F0_2_W { w: self }
    }
    #[doc = "Bits 24:31 - Fifo 0 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn f0_3(&mut self) -> F0_3_W {
        F0_3_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "FIFO 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [f02](index.html) module"]
pub struct F02_SPEC;
impl crate::RegisterSpec for F02_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [f02::R](R) reader structure"]
impl crate::Readable for F02_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [f02::W](W) writer structure"]
impl crate::Writable for F02_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets F02 to value 0"]
impl crate::Resettable for F02_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
